#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>
#include <string.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20070509

#define YYEMPTY (-1)
#define yyclearin    (yychar = YYEMPTY)
#define yyerrok      (yyerrflag = 0)
#define YYRECOVERING (yyerrflag != 0)

extern int yyparse(void);

static int yygrowstack(void);
#define YYPREFIX "yy"
#line 17 "gram.y"
#include <config.h>
#include <includes.h>
#include <radvd.h>
#include <defaults.h>

extern struct Interface *IfaceList;
struct Interface *iface = NULL;
struct AdvPrefix *prefix = NULL;
struct AdvRoute *route = NULL;
struct AdvRDNSS *rdnss = NULL;

extern char *conf_file;
extern int num_lines;
extern char *yytext;
extern int sock;

static void cleanup(void);
static void yyerror(char *msg);

#if 0 /* no longer necessary? */
#ifndef HAVE_IN6_ADDR_S6_ADDR
# ifdef __FreeBSD__
#  define s6_addr32 __u6_addr.__u6_addr32
#  define s6_addr16 __u6_addr.__u6_addr16
# endif
#endif
#endif

#define ABORT	do { cleanup(); YYABORT; } while (0);
#define ADD_TO_LL(type, list, value) \
	do { \
		if (iface->list == NULL) \
			iface->list = value; \
		else { \
			type *current = iface->list; \
			while (current->next != NULL) \
				current = current->next; \
			current->next = value; \
		} \
	} while (0)


#line 124 "gram.y"
typedef union {
	unsigned int		num;
	int			snum;
	double			dec;
	struct in6_addr		*addr;
	char			*str;
	struct AdvPrefix	*pinfo;
	struct AdvRoute		*rinfo;
	struct AdvRDNSS		*rdnssinfo;
	struct Clients		*ainfo;
} YYSTYPE;
#line 78 "gram.c"
#define T_INTERFACE 257
#define T_PREFIX 258
#define T_ROUTE 259
#define T_RDNSS 260
#define T_CLIENTS 261
#define STRING 262
#define NUMBER 263
#define SIGNEDNUMBER 264
#define DECIMAL 265
#define SWITCH 266
#define IPV6ADDR 267
#define INFINITY 268
#define T_IgnoreIfMissing 269
#define T_AdvSendAdvert 270
#define T_MaxRtrAdvInterval 271
#define T_MinRtrAdvInterval 272
#define T_MinDelayBetweenRAs 273
#define T_AdvManagedFlag 274
#define T_AdvOtherConfigFlag 275
#define T_AdvLinkMTU 276
#define T_AdvReachableTime 277
#define T_AdvRetransTimer 278
#define T_AdvCurHopLimit 279
#define T_AdvDefaultLifetime 280
#define T_AdvDefaultPreference 281
#define T_AdvSourceLLAddress 282
#define T_AdvOnLink 283
#define T_AdvAutonomous 284
#define T_AdvValidLifetime 285
#define T_AdvPreferredLifetime 286
#define T_AdvRouterAddr 287
#define T_AdvHomeAgentFlag 288
#define T_AdvIntervalOpt 289
#define T_AdvHomeAgentInfo 290
#define T_Base6to4Interface 291
#define T_UnicastOnly 292
#define T_HomeAgentPreference 293
#define T_HomeAgentLifetime 294
#define T_AdvRoutePreference 295
#define T_AdvRouteLifetime 296
#define T_AdvRDNSSPreference 297
#define T_AdvRDNSSOpenFlag 298
#define T_AdvRDNSSLifetime 299
#define T_AdvMobRtrSupportFlag 300
#define T_BAD_TOKEN 301
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    8,    9,    1,   10,   10,   11,   11,   11,
   11,   11,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,    3,    4,    4,    2,
   13,   14,   14,   15,   15,   16,   16,   16,   16,   16,
   16,    5,   17,   18,   18,   19,   19,   20,   20,    6,
   23,   23,   24,   21,   22,   22,   25,   25,   26,   26,
   26,    7,    7,
};
short yylen[] = {                                         2,
    2,    1,    5,    2,    1,    0,    2,    1,    1,    1,
    1,    1,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    5,    2,    3,    5,
    4,    0,    1,    2,    1,    3,    3,    3,    3,    3,
    3,    5,    4,    0,    1,    2,    1,    3,    3,    5,
    2,    1,    1,    2,    0,    1,    2,    1,    3,    3,
    3,    1,    1,
};
short yydefred[] = {                                      0,
    0,    0,    2,    0,    5,    4,    1,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    9,   10,   11,   12,    0,    0,    8,
    0,    0,    0,    0,    0,   63,    0,   62,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    7,    0,    0,    0,    0,    0,
   61,    0,    0,   19,   20,   14,   17,   13,   16,   15,
   18,   21,   22,   23,   24,   25,   28,   26,   27,   29,
   32,   30,   31,   35,   33,   34,   36,    3,    0,    0,
    0,    0,    0,    0,    0,    0,   45,    0,    0,    0,
    0,   57,    0,    0,    0,    0,    0,   68,   41,   53,
   38,    0,    0,    0,    0,   72,   73,    0,    0,    0,
    0,    0,   44,    0,    0,    0,   56,    0,    0,    0,
    0,   67,   39,   37,   46,   47,   49,   50,   48,   51,
   40,   58,   59,   52,   69,   70,   71,   60,
};
short yydgoto[] = {                                       2,
    6,   34,   35,   83,   36,   37,  138,    3,    4,   38,
   39,   40,   41,  115,  116,  117,   42,  120,  121,  122,
   43,  126,   47,   48,  127,  128,
};
short yysindex[] = {                                   -219,
 -220, -219,    0,  -74,    0,    0,    0, -257, -217, -216,
 -214,  -69, -211, -210, -254, -237, -224, -209, -208, -204,
 -203, -202, -201, -200, -199, -198, -197, -196, -195, -194,
 -190, -189, -191,    0,    0,    0,    0,  -61, -257,    0,
  -57,  -56,  -47,   30,   31,    0, -214,    0, -188,   21,
   22,   23,   24,   25,   26,   27,   28,   29,   32,   33,
   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
   44,   45,   46,   47,    0, -239, -266, -291, -174, -173,
    0,   48, -125,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -158, -157,
 -258, -258, -156, -220,  -14, -239,    0, -152, -258,  -12,
 -266,    0, -149, -151, -258,   -9, -291,    0,    0,    0,
    0,   58,   59,   60,   61,    0,    0,   62,   63,   64,
   65,   66,    0,   67,   68,   69,    0,   70,   71,   72,
   73,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    8,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    8,    0,
    0,    0,    0,    0,    0,    0,   11,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   10,   12,   13,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   14,    0,    0,    0,    0,
   15,    0,    0,    0,    0,    0,   16,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
   49,    0,    0,    0,    0,    0,  -85,  134,    0,  104,
    0,    0,    0,    0,    0,   50,    0,    0,    0,   51,
    0,    0,    0,   97,    0,   18,
};
#define YYTABLESIZE 172
short yytable[] = {                                     133,
    9,   10,   11,   12,  136,  123,  124,  125,   52,  137,
   53,   13,   14,   15,   16,   17,   18,   19,   20,   21,
   22,   23,   24,   25,   26,   54,  139,   55,  118,  119,
   27,   28,   29,  145,   30,   31,   32,    1,   56,  150,
   57,    5,   33,  109,  110,  111,  112,  113,    8,   44,
   45,  114,   46,   49,   50,   51,   58,   59,   60,   61,
   62,   63,   64,   74,   65,   76,   77,   66,   67,   68,
   69,   70,   71,   72,   73,   78,   79,   80,   82,   84,
   85,   86,   87,   88,   89,   90,   91,   92,  129,  130,
   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
  103,  104,  105,  106,  107,  108,  131,  134,  135,  140,
  142,  144,  146,  148,  149,  151,  153,  154,  155,  156,
  157,  158,  159,  160,  161,  162,  163,  164,  165,  166,
  167,  168,    6,   64,   42,    7,   54,   65,   43,   55,
   66,  132,   75,   81,  152,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  141,    0,    0,  143,    0,    0,    0,    0,
    0,  147,
};
short yycheck[] = {                                     125,
  258,  259,  260,  261,  263,  297,  298,  299,  263,  268,
  265,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  263,  112,  265,  295,  296,
  288,  289,  290,  119,  292,  293,  294,  257,  263,  125,
  265,  262,  300,  283,  284,  285,  286,  287,  123,  267,
  267,  291,  267,  123,  266,  266,  266,  266,  263,  263,
  263,  263,  263,  125,  264,  123,  123,  266,  266,  266,
  266,  266,  263,  263,  266,  123,   47,   47,  267,   59,
   59,   59,   59,   59,   59,   59,   59,   59,  263,  263,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,  266,  266,  266,
  125,  264,  125,  263,  266,  125,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,   59,  125,  123,  125,    2,  125,  125,  125,  125,
  125,  267,   39,   47,  127,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  114,   -1,   -1,  116,   -1,   -1,   -1,   -1,
   -1,  121,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 301
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'/'",0,0,0,0,0,0,0,0,0,0,0,"';'",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"T_INTERFACE",
"T_PREFIX","T_ROUTE","T_RDNSS","T_CLIENTS","STRING","NUMBER","SIGNEDNUMBER",
"DECIMAL","SWITCH","IPV6ADDR","INFINITY","T_IgnoreIfMissing","T_AdvSendAdvert",
"T_MaxRtrAdvInterval","T_MinRtrAdvInterval","T_MinDelayBetweenRAs",
"T_AdvManagedFlag","T_AdvOtherConfigFlag","T_AdvLinkMTU","T_AdvReachableTime",
"T_AdvRetransTimer","T_AdvCurHopLimit","T_AdvDefaultLifetime",
"T_AdvDefaultPreference","T_AdvSourceLLAddress","T_AdvOnLink","T_AdvAutonomous",
"T_AdvValidLifetime","T_AdvPreferredLifetime","T_AdvRouterAddr",
"T_AdvHomeAgentFlag","T_AdvIntervalOpt","T_AdvHomeAgentInfo",
"T_Base6to4Interface","T_UnicastOnly","T_HomeAgentPreference",
"T_HomeAgentLifetime","T_AdvRoutePreference","T_AdvRouteLifetime",
"T_AdvRDNSSPreference","T_AdvRDNSSOpenFlag","T_AdvRDNSSLifetime",
"T_AdvMobRtrSupportFlag","T_BAD_TOKEN",
};
char *yyrule[] = {
"$accept : grammar",
"grammar : grammar ifacedef",
"grammar : ifacedef",
"ifacedef : ifacehead '{' ifaceparams '}' ';'",
"ifacehead : T_INTERFACE name",
"name : STRING",
"ifaceparams :",
"ifaceparams : ifaceparam ifaceparams",
"ifaceparam : ifaceval",
"ifaceparam : prefixdef",
"ifaceparam : clientslist",
"ifaceparam : routedef",
"ifaceparam : rdnssdef",
"ifaceval : T_MinRtrAdvInterval NUMBER ';'",
"ifaceval : T_MaxRtrAdvInterval NUMBER ';'",
"ifaceval : T_MinDelayBetweenRAs NUMBER ';'",
"ifaceval : T_MinRtrAdvInterval DECIMAL ';'",
"ifaceval : T_MaxRtrAdvInterval DECIMAL ';'",
"ifaceval : T_MinDelayBetweenRAs DECIMAL ';'",
"ifaceval : T_IgnoreIfMissing SWITCH ';'",
"ifaceval : T_AdvSendAdvert SWITCH ';'",
"ifaceval : T_AdvManagedFlag SWITCH ';'",
"ifaceval : T_AdvOtherConfigFlag SWITCH ';'",
"ifaceval : T_AdvLinkMTU NUMBER ';'",
"ifaceval : T_AdvReachableTime NUMBER ';'",
"ifaceval : T_AdvRetransTimer NUMBER ';'",
"ifaceval : T_AdvDefaultLifetime NUMBER ';'",
"ifaceval : T_AdvDefaultPreference SIGNEDNUMBER ';'",
"ifaceval : T_AdvCurHopLimit NUMBER ';'",
"ifaceval : T_AdvSourceLLAddress SWITCH ';'",
"ifaceval : T_AdvIntervalOpt SWITCH ';'",
"ifaceval : T_AdvHomeAgentInfo SWITCH ';'",
"ifaceval : T_AdvHomeAgentFlag SWITCH ';'",
"ifaceval : T_HomeAgentPreference NUMBER ';'",
"ifaceval : T_HomeAgentLifetime NUMBER ';'",
"ifaceval : T_UnicastOnly SWITCH ';'",
"ifaceval : T_AdvMobRtrSupportFlag SWITCH ';'",
"clientslist : T_CLIENTS '{' v6addrlist '}' ';'",
"v6addrlist : IPV6ADDR ';'",
"v6addrlist : v6addrlist IPV6ADDR ';'",
"prefixdef : prefixhead '{' optional_prefixplist '}' ';'",
"prefixhead : T_PREFIX IPV6ADDR '/' NUMBER",
"optional_prefixplist :",
"optional_prefixplist : prefixplist",
"prefixplist : prefixplist prefixparms",
"prefixplist : prefixparms",
"prefixparms : T_AdvOnLink SWITCH ';'",
"prefixparms : T_AdvAutonomous SWITCH ';'",
"prefixparms : T_AdvRouterAddr SWITCH ';'",
"prefixparms : T_AdvValidLifetime number_or_infinity ';'",
"prefixparms : T_AdvPreferredLifetime number_or_infinity ';'",
"prefixparms : T_Base6to4Interface name ';'",
"routedef : routehead '{' optional_routeplist '}' ';'",
"routehead : T_ROUTE IPV6ADDR '/' NUMBER",
"optional_routeplist :",
"optional_routeplist : routeplist",
"routeplist : routeplist routeparms",
"routeplist : routeparms",
"routeparms : T_AdvRoutePreference SIGNEDNUMBER ';'",
"routeparms : T_AdvRouteLifetime number_or_infinity ';'",
"rdnssdef : rdnsshead '{' optional_rdnssplist '}' ';'",
"rdnssaddrs : rdnssaddrs rdnssaddr",
"rdnssaddrs : rdnssaddr",
"rdnssaddr : IPV6ADDR",
"rdnsshead : T_RDNSS rdnssaddrs",
"optional_rdnssplist :",
"optional_rdnssplist : rdnssplist",
"rdnssplist : rdnssplist rdnssparms",
"rdnssplist : rdnssparms",
"rdnssparms : T_AdvRDNSSPreference NUMBER ';'",
"rdnssparms : T_AdvRDNSSOpenFlag SWITCH ';'",
"rdnssparms : T_AdvRDNSSLifetime number_or_infinity ';'",
"number_or_infinity : NUMBER",
"number_or_infinity : INFINITY",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;
int      yyerrflag;
int      yychar;
short   *yyssp;
YYSTYPE *yyvsp;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static short   *yyss;
static short   *yysslim;
static YYSTYPE *yyvs;
static int      yystacksize;
#line 636 "gram.y"

static
void cleanup(void)
{
	if (iface)
		free(iface);
	
	if (prefix)
		free(prefix);

	if (route)
		free(route);

	if (rdnss)
		free(rdnss);
}

static void
yyerror(char *msg)
{
	cleanup();
	flog(LOG_ERR, "%s in %s, line %d: %s", msg, conf_file, num_lines, yytext);
}
#line 414 "gram.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = yyssp - yyss;
    newss = (yyss != 0)
          ? (short *)realloc(yyss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    yyss  = newss;
    yyssp = newss + i;
    newvs = (yyvs != 0)
          ? (YYSTYPE *)realloc(yyvs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

#ifdef lint
    goto yyerrlab;
#endif

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 3:
#line 143 "gram.y"
{
			struct Interface *iface2;

			iface2 = IfaceList;
			while (iface2)
			{
				if (!strcmp(iface2->Name, iface->Name))
				{
					flog(LOG_ERR, "duplicate interface "
						"definition for %s", iface->Name);
					ABORT;
				}
				iface2 = iface2->next;
			}			

			if (check_device(sock, iface) < 0) {
				if (iface->IgnoreIfMissing) {
					dlog(LOG_DEBUG, 4, "interface %s did not exist, ignoring the interface", iface->Name);
				}
				else {
					flog(LOG_ERR, "interface %s does not exist", iface->Name);
					ABORT;
				}
			}
			if (setup_deviceinfo(sock, iface) < 0)
				if (!iface->IgnoreIfMissing)
				ABORT;
			if (check_iface(iface) < 0)
				if (!iface->IgnoreIfMissing)
				ABORT;
			if (setup_linklocal_addr(sock, iface) < 0)
				if (!iface->IgnoreIfMissing)
				ABORT;
			if (setup_allrouters_membership(sock, iface) < 0)
				if (!iface->IgnoreIfMissing)
				ABORT;

			dlog(LOG_DEBUG, 4, "interface definition for %s is ok", iface->Name);

			iface->next = IfaceList;
			IfaceList = iface;

			iface = NULL;
		}
break;
case 4:
#line 189 "gram.y"
{
			iface = malloc(sizeof(struct Interface));

			if (iface == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			iface_init_defaults(iface);
			strncpy(iface->Name, yyvsp[0].str, IFNAMSIZ-1);
			iface->Name[IFNAMSIZ-1] = '\0';
		}
break;
case 5:
#line 204 "gram.y"
{
			/* check vality */
			yyval.str = yyvsp[0].str;
		}
break;
case 9:
#line 216 "gram.y"
{ ADD_TO_LL(struct AdvPrefix, AdvPrefixList, yyvsp[0].pinfo); }
break;
case 10:
#line 217 "gram.y"
{ ADD_TO_LL(struct Clients, ClientList, yyvsp[0].ainfo); }
break;
case 11:
#line 218 "gram.y"
{ ADD_TO_LL(struct AdvRoute, AdvRouteList, yyvsp[0].rinfo); }
break;
case 12:
#line 219 "gram.y"
{ ADD_TO_LL(struct AdvRDNSS, AdvRDNSSList, yyvsp[0].rdnssinfo); }
break;
case 13:
#line 223 "gram.y"
{
			iface->MinRtrAdvInterval = yyvsp[-1].num;
		}
break;
case 14:
#line 227 "gram.y"
{
			iface->MaxRtrAdvInterval = yyvsp[-1].num;
		}
break;
case 15:
#line 231 "gram.y"
{
			iface->MinDelayBetweenRAs = yyvsp[-1].num;
		}
break;
case 16:
#line 235 "gram.y"
{
			iface->MinRtrAdvInterval = yyvsp[-1].dec;
		}
break;
case 17:
#line 239 "gram.y"
{
			iface->MaxRtrAdvInterval = yyvsp[-1].dec;
		}
break;
case 18:
#line 243 "gram.y"
{
			iface->MinDelayBetweenRAs = yyvsp[-1].dec;
		}
break;
case 19:
#line 247 "gram.y"
{
			iface->IgnoreIfMissing = yyvsp[-1].num;
		}
break;
case 20:
#line 251 "gram.y"
{
			iface->AdvSendAdvert = yyvsp[-1].num;
		}
break;
case 21:
#line 255 "gram.y"
{
			iface->AdvManagedFlag = yyvsp[-1].num;
		}
break;
case 22:
#line 259 "gram.y"
{
			iface->AdvOtherConfigFlag = yyvsp[-1].num;
		}
break;
case 23:
#line 263 "gram.y"
{
			iface->AdvLinkMTU = yyvsp[-1].num;
		}
break;
case 24:
#line 267 "gram.y"
{
			iface->AdvReachableTime = yyvsp[-1].num;
		}
break;
case 25:
#line 271 "gram.y"
{
			iface->AdvRetransTimer = yyvsp[-1].num;
		}
break;
case 26:
#line 275 "gram.y"
{
			iface->AdvDefaultLifetime = yyvsp[-1].num;
		}
break;
case 27:
#line 279 "gram.y"
{
			iface->AdvDefaultPreference = yyvsp[-1].snum;
		}
break;
case 28:
#line 283 "gram.y"
{
			iface->AdvCurHopLimit = yyvsp[-1].num;
		}
break;
case 29:
#line 287 "gram.y"
{
			iface->AdvSourceLLAddress = yyvsp[-1].num;
		}
break;
case 30:
#line 291 "gram.y"
{
			iface->AdvIntervalOpt = yyvsp[-1].num;
		}
break;
case 31:
#line 295 "gram.y"
{
			iface->AdvHomeAgentInfo = yyvsp[-1].num;
		}
break;
case 32:
#line 299 "gram.y"
{
			iface->AdvHomeAgentFlag = yyvsp[-1].num;
		}
break;
case 33:
#line 303 "gram.y"
{
			iface->HomeAgentPreference = yyvsp[-1].num;
		}
break;
case 34:
#line 307 "gram.y"
{
			iface->HomeAgentLifetime = yyvsp[-1].num;
		}
break;
case 35:
#line 311 "gram.y"
{
			iface->UnicastOnly = yyvsp[-1].num;
		}
break;
case 36:
#line 315 "gram.y"
{
			iface->AdvMobRtrSupportFlag = yyvsp[-1].num;
		}
break;
case 37:
#line 321 "gram.y"
{
			yyval.ainfo = yyvsp[-2].ainfo;
		}
break;
case 38:
#line 327 "gram.y"
{
			struct Clients *new = calloc(1, sizeof(struct Clients));
			if (new == NULL) {
				flog(LOG_CRIT, "calloc failed: %s", strerror(errno));
				ABORT;
			}

			memcpy(&(new->Address), yyvsp[-1].addr, sizeof(struct in6_addr));
			yyval.ainfo = new;
		}
break;
case 39:
#line 338 "gram.y"
{
			struct Clients *new = calloc(1, sizeof(struct Clients));
			if (new == NULL) {
				flog(LOG_CRIT, "calloc failed: %s", strerror(errno));
				ABORT;
			}

			memcpy(&(new->Address), yyvsp[-1].addr, sizeof(struct in6_addr));
			new->next = yyvsp[-2].ainfo;
			yyval.ainfo = new;
		}
break;
case 40:
#line 353 "gram.y"
{
			unsigned int dst;

			if (prefix->AdvPreferredLifetime >
			    prefix->AdvValidLifetime)
			{
				flog(LOG_ERR, "AdvValidLifeTime must be "
					"greater than AdvPreferredLifetime in %s, line %d", 
					conf_file, num_lines);
				ABORT;
			}

			if( prefix->if6to4[0] )
			{
				if (get_v4addr(prefix->if6to4, &dst) < 0)
				{
					flog(LOG_ERR, "interface %s has no IPv4 addresses, disabling 6to4 prefix", prefix->if6to4 );
					prefix->enabled = 0;
				} else
				{
					*((uint16_t *)(prefix->Prefix.s6_addr)) = htons(0x2002);
					memcpy( prefix->Prefix.s6_addr + 2, &dst, sizeof( dst ) );
				}
			}

			yyval.pinfo = prefix;
			prefix = NULL;
		}
break;
case 41:
#line 384 "gram.y"
{
			struct in6_addr zeroaddr;
			prefix = malloc(sizeof(struct AdvPrefix));
			
			if (prefix == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			prefix_init_defaults(prefix);

			if (yyvsp[0].num > MAX_PrefixLen)
			{
				flog(LOG_ERR, "invalid prefix length in %s, line %d", conf_file, num_lines);
				ABORT;
			}

			prefix->PrefixLen = yyvsp[0].num;

			memcpy(&prefix->Prefix, yyvsp[-2].addr, sizeof(struct in6_addr));

			memset(&zeroaddr, 0, sizeof(zeroaddr));
			if (!memcmp(yyvsp[-2].addr, &zeroaddr, sizeof(struct in6_addr))) {
#ifndef HAVE_IFADDRS_H
				flog(LOG_ERR, "invalid all-zeros prefix in %s, line %d", conf_file, num_lines);
				ABORT;
#else
				dlog(LOG_DEBUG, 5, "all-zeros prefix in %s, line %d, parsing..", conf_file, num_lines);
				struct ifaddrs *ifap, *ifa;
				if (getifaddrs(&ifap) != 0)
					flog(LOG_ERR, "getifaddrs failed: %s", strerror(errno));
			        for (ifa = ifap; ifa; ifa = ifa->ifa_next) {
				        struct sockaddr_in6 *s6;
					char buf[INET6_ADDRSTRLEN];
					if (strncmp(ifa->ifa_name, iface->Name, IFNAMSIZ))
						continue;
                			if (ifa->ifa_addr->sa_family != AF_INET6)
			                        continue;
					s6 = (struct sockaddr_in6 *)(ifa->ifa_addr);
	                		if (IN6_IS_ADDR_LINKLOCAL(&s6->sin6_addr))
						continue;
					if (inet_ntop(ifa->ifa_addr->sa_family, (void *)&(s6->sin6_addr), buf, sizeof(buf)) == NULL) {
						flog(LOG_ERR, "%s: inet_ntop failed in %s, line %d!", ifa->ifa_name, conf_file, num_lines);
					}
					else {
						dlog(LOG_DEBUG, 5, "auto-selected prefix %s on interface %s", buf, ifa->ifa_name);
						memcpy(&prefix->Prefix, &s6->sin6_addr, sizeof(struct in6_addr));
						prefix->AdvRouterAddr=1;
						prefix->AutoSelected=1;
					}
				}
				if (!memcmp(&prefix->Prefix, &zeroaddr, sizeof(struct in6_addr))) {
					prefix->enabled = 0;
					flog(LOG_WARNING, "no auto-selected prefix on interface %s, disabling advertisements",  iface->Name);
				}
				freeifaddrs(ifap);
				freeifaddrs(ifa);
#endif /* ifndef HAVE_IFADDRS_H */
			}
		}
break;
case 46:
#line 455 "gram.y"
{
			prefix->AdvOnLinkFlag = yyvsp[-1].num;
		}
break;
case 47:
#line 459 "gram.y"
{
			prefix->AdvAutonomousFlag = yyvsp[-1].num;
		}
break;
case 48:
#line 463 "gram.y"
{
			if (prefix->AutoSelected && yyvsp[-1].num == 0)
				flog(LOG_WARNING, "prefix automatically selected, AdvRouterAddr always enabled, ignoring config line %d", num_lines);
			else  
				prefix->AdvRouterAddr = yyvsp[-1].num;
		}
break;
case 49:
#line 470 "gram.y"
{
			prefix->AdvValidLifetime = yyvsp[-1].num;
		}
break;
case 50:
#line 474 "gram.y"
{
			prefix->AdvPreferredLifetime = yyvsp[-1].num;
		}
break;
case 51:
#line 478 "gram.y"
{
			if (prefix->AutoSelected) {
				flog(LOG_ERR, "automatically selecting the prefix and Base6to4Interface are mutually exclusive");
				ABORT;
			} /* fallthrough */
			dlog(LOG_DEBUG, 4, "using interface %s for 6to4", yyvsp[-1].str);
			strncpy(prefix->if6to4, yyvsp[-1].str, IFNAMSIZ-1);
			prefix->if6to4[IFNAMSIZ-1] = '\0';
		}
break;
case 52:
#line 490 "gram.y"
{
			yyval.rinfo = route;
			route = NULL;
		}
break;
case 53:
#line 498 "gram.y"
{
			route = malloc(sizeof(struct AdvRoute));
			
			if (route == NULL) {
				flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
				ABORT;
			}

			route_init_defaults(route, iface);

			if (yyvsp[0].num > MAX_PrefixLen)
			{
				flog(LOG_ERR, "invalid route prefix length in %s, line %d", conf_file, num_lines);
				ABORT;
			}

			route->PrefixLen = yyvsp[0].num;

			memcpy(&route->Prefix, yyvsp[-2].addr, sizeof(struct in6_addr));
		}
break;
case 58:
#line 531 "gram.y"
{
			route->AdvRoutePreference = yyvsp[-1].snum;
		}
break;
case 59:
#line 535 "gram.y"
{
			route->AdvRouteLifetime = yyvsp[-1].num;
		}
break;
case 60:
#line 541 "gram.y"
{
			yyval.rdnssinfo = rdnss;
			rdnss = NULL;
		}
break;
case 63:
#line 552 "gram.y"
{
			if (!rdnss) {
				/* first IP found */
				rdnss = malloc(sizeof(struct AdvRDNSS));
				
				if (rdnss == NULL) {
					flog(LOG_CRIT, "malloc failed: %s", strerror(errno));
					ABORT;
				}

				rdnss_init_defaults(rdnss, iface);
			}
			
			switch (rdnss->AdvRDNSSNumber) {
				case 0:
					memcpy(&rdnss->AdvRDNSSAddr1, yyvsp[0].addr, sizeof(struct in6_addr));
					rdnss->AdvRDNSSNumber++;
					break;
				case 1:
					memcpy(&rdnss->AdvRDNSSAddr2, yyvsp[0].addr, sizeof(struct in6_addr));
					rdnss->AdvRDNSSNumber++;
					break;
				case 2:
					memcpy(&rdnss->AdvRDNSSAddr3, yyvsp[0].addr, sizeof(struct in6_addr));
					rdnss->AdvRDNSSNumber++;
					break;
				default:
					flog(LOG_CRIT, "Too many addresses in RDNSS section");
					ABORT;
			}
			
		}
break;
case 64:
#line 587 "gram.y"
{
			if (!rdnss) {
				flog(LOG_CRIT, "No address specified in RDNSS section");
				ABORT;
			}
		}
break;
case 69:
#line 605 "gram.y"
{
			rdnss->AdvRDNSSPreference = yyvsp[-1].num;
		}
break;
case 70:
#line 609 "gram.y"
{
			rdnss->AdvRDNSSOpenFlag = yyvsp[-1].num;
		}
break;
case 71:
#line 613 "gram.y"
{
			if (yyvsp[-1].num < iface->MaxRtrAdvInterval && yyvsp[-1].num != 0) {
				flog(LOG_ERR, "AdvRDNSSLifetime must be at least MaxRtrAdvInterval");
				ABORT;
			}
			if (yyvsp[-1].num > 2*(iface->MaxRtrAdvInterval))
				flog(LOG_WARNING, "Warning: AdvRDNSSLifetime <= 2*MaxRtrAdvInterval would allow stale DNS servers to be deleted faster");

			rdnss->AdvRDNSSLifetime = yyvsp[-1].num;
		}
break;
case 72:
#line 626 "gram.y"
{
                                yyval.num = yyvsp[0].num; 
                        }
break;
case 73:
#line 630 "gram.y"
{
                                yyval.num = (uint32_t)~0;
                        }
break;
#line 1126 "gram.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    return (1);

yyaccept:
    return (0);
}
